package com.rymcu.vertical.wx.mp.controller;

import com.rymcu.vertical.util.ContextHolderUtils;
import me.chanjar.weixin.common.api.WxConsts;
import me.chanjar.weixin.common.bean.WxJsapiSignature;
import me.chanjar.weixin.common.error.WxErrorException;
import me.chanjar.weixin.common.util.http.URIUtil;
import me.chanjar.weixin.mp.api.WxMpService;
import me.chanjar.weixin.mp.bean.result.WxMpOAuth2AccessToken;
import me.chanjar.weixin.mp.bean.result.WxMpUser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;

/**
 * @author ronger
 */
@Controller
@RequestMapping("/wx/oauth/{appId}")
public class WxoAuthController {

    @Resource
    private WxMpService wxMpService;

    @Value("${resource.domain}")
    private String domain;

    @GetMapping
    public String wxAuth(@PathVariable String appId, @RequestParam(name = "redirectUrl") String redirectUrl) {
        wxMpService.switchoverTo(appId);
        if ("wxa49093339a5a822b".equals(appId)) {
            domain = "http://oae.nat300.top/vertical";
        } else {
            domain += "/vertical-console";
        }
        StringBuilder accessTokenUrl = new StringBuilder(domain).append("/wx/oauth/" + appId + "/getAccessToken?redirectUrl=").append(URIUtil.encodeURIComponent(domain + redirectUrl));
        String oauth2Url = wxMpService.oauth2buildAuthorizationUrl(accessTokenUrl.toString(), WxConsts.OAuth2Scope.SNSAPI_BASE, null);
        return "redirect:" + oauth2Url;
    }

    @GetMapping("getAccessToken")
    public String getAccessToken(@PathVariable String appId, @RequestParam(name = "code") String code, @RequestParam(name = "redirectUrl") String redirectUrl) throws Exception {
        wxMpService.switchoverTo(appId);
        WxMpOAuth2AccessToken oAuth2AccessToken = wxMpService.oauth2getAccessToken(code);
        boolean valid = wxMpService.oauth2validateAccessToken(oAuth2AccessToken);
        if (!valid) {
            throw new Exception("无权限");
        }

        WxMpUser wxMpUser =wxMpService.getUserService().userInfo(oAuth2AccessToken.getOpenId());
        ContextHolderUtils.getSession2().setAttribute("wxUser", wxMpUser);
        return "redirect:" + redirectUrl;
    }

    @GetMapping("validJs")
    @ResponseBody
    public WxJsapiSignature validJs(String url) throws WxErrorException {
        return wxMpService.createJsapiSignature(url);
    }

    @GetMapping("t")
    public String reOauth() {
        return "wx/oauth";
    }
}
